freeslot(
"S_PLAY_FALLEN",
"sfx_drexpl"
)
sfxinfo[sfx_drexpl].caption = "Deltarune Explosion"

if not customdeaths
	rawset(_G, "customdeaths", {})
end

customdeaths["kris"] = true
customdeaths["susie"] = true
customdeaths["ralsei"] = true
customdeaths["adventuresonic"] = true
customdeaths["pointy"] = true
customdeaths["fluffy"] = true
customdeaths["mario"] = true
customdeaths["luigi"] = true

addHook("PlayerSpawn", function(p)
	if not customdeaths[p.mo.skin]
		p.deathstate = 0
		p.deathType = "NONE" -- 0 None -- 1 Pit -- 2 Fire -- 3 Self -- 4 Object
		p.savedmomx = 0
		p.savedmomy = 0
		p.savedmomz = 0
	end
end)

local function MobjValid(mobj)
	return mobj and mobj.valid
end

local function PlayerDeath(mobj, inflictor, source, damageType)
	if not customdeaths[mobj.skin]
		if damageType == DMG_DEATHPIT
			mobj.player.deathType = "PIT"
			mobj.player.savedmomx = mobj.momx
			mobj.player.savedmomy = mobj.momy
			mobj.player.savedmomz = mobj.momz
		end
		if damageType == DMG_FIRE or damageType == DMG_ELECTRIC
			if P_PlayerTouchingSectorSpecial(mobj.player, 1, 3)
				mobj.player.deathType = "LAVA"
			else
			mobj.player.deathType = "FIRE"
			end
		end
		if inflictor == mobj or damageType == DMG_SPIKE or damageType == DMG_WATER // killed by self
			mobj.player.deathType = "SELF"
		end
		if MobjValid(inflictor) // killed by object
			if inflictor.type == MT_TNTBARREL or inflictor.type == MT_PROXIMITYTNT 
			mobj.player.deathType = "BOOM"
			else
				if damageType == DMG_FIRE
				mobj.player.deathType = "FIRE"
				mobj.player.drawangle = R_PointToAngle2(mobj.x, mobj.y, inflictor.x, inflictor.y)
				else
					mobj.player.deathType = "OBJECT"
				mobj.player.drawangle = R_PointToAngle2(mobj.x, mobj.y, inflictor.x, inflictor.y)
				end
			end
		end
		if damageType == DMG_DROWNED or damageType == DMG_SPACEDROWN
			if (mobj.player.charflags & SF_MACHINE and damageType == DMG_SPACEDROWN) then
				mobj.player.deathType = "OVERHEAT"
			else
			mobj.player.deathType = "DROWN"
			end
		end
		if mobj.player.deathType == "NONE"
			mobj.player.deathType = "SELF"
		end
	end
end

local function DoPlayerDeath(player)
	if not customdeaths[player.mo.skin] 
		if player.deathType == "PIT"
			if P_CheckDeathPitCollide(player.mo) and player.deathstate == 1
			player.mo.flags = $|MF_NOCLIPHEIGHT
			player.mo.state = S_PLAY_PAIN
			player.mo.momz = player.savedmomz + (-1*FRACUNIT*P_MobjFlip(player.mo))
			player.deathstate = 2
			end
			if P_InSpaceSector(player.mo)
				local fire = P_SpawnMobj(player.mo.x+(P_RandomRange(-4,4)*player.mo.scale),player.mo.y+(P_RandomRange(-4,4)*player.mo.scale) ,player.mo.z+(P_RandomRange(-15,45)*player.mo.scale), MT_SPINDUST)
				fire.state = S_SPINDUST_FIRE1
			end
			player.mo.drawangle = R_PointToAngle2(0, 0, player.mo.momx, player.mo.momy)
		end
		if player.deathType == "LAVA" 
			if player.deathstate == 1 
				P_SetObjectMomZ(player.mo, 12*FRACUNIT, false)
				player.mo.color = SKINCOLOR_CARBON
				player.mo.colorized = true
				S_StartSound(player.mo, sfx_drexpl)
				P_StartQuake(24*FRACUNIT, 10)
				local kaboom = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_PELOBOOM)
				kaboom.spritexscale = FRACUNIT/2
				kaboom.spriteyscale = FRACUNIT/2
				player.deathstate = 2
			elseif not P_IsObjectOnGround(player.mo) and player.deathstate == 2
				player.mo.rollangle = $ + ANGLE_22h
				if P_InSpaceSector(player.mo)
				player.mo.momz = $ + (-1*P_GetMobjGravity(player.mo))
				else
				player.mo.momz = $ + (-1*P_GetMobjGravity(player.mo)/2)
				end
				P_InstaThrust(player.mo, player.drawangle, 12*player.mo.scale)
				A_BossScream(player.mo, 1, MT_SMOKE)
				local fire = P_SpawnMobj(player.mo.x+(P_RandomRange(-4,4)*player.mo.scale),player.mo.y+(P_RandomRange(-4,4)*player.mo.scale) ,player.mo.z+(P_RandomRange(-15,45)*player.mo.scale), MT_SPINDUST)
				fire.state = S_SPINDUST_FIRE1
			else
				if P_MobjFlip(player.mo)
					player.mo.z = player.mo.floorz
					player.mo.momz = 0
				else
					player.mo.z = player.mo.ceilingz
					player.mo.momz = 0
				end
				player.mo.state = S_PLAY_FALLEN
				P_InstaThrust(player.mo, player.drawangle, 0*player.mo.scale)
				player.mo.rollangle = 0
				local fire = P_SpawnMobj(player.mo.x+(P_RandomRange(-10,10)*player.mo.scale),player.mo.y+(P_RandomRange(-10,10)*player.mo.scale) ,player.mo.z+(P_RandomRange(-15,25)*player.mo.scale), MT_SPINDUST)
				fire.state = S_SPINDUST_FIRE1
				if player.deathstate == 2
				S_StartSound(player.mo, sfx_s3k4c)
				player.deathstate = 3
				end
			end
		end
		if player.deathType == "FIRE" 
			if player.deathstate == 1 
				player.mo.state = S_PLAY_PAIN
				player.mo.momz = $ + P_MobjFlip(player.mo)
				player.mo.color = SKINCOLOR_CARBON
				player.mo.colorized = true
				P_SetObjectMomZ(player.mo, 6*FRACUNIT)
				P_InstaThrust(player.mo, player.drawangle + ANGLE_180, 12*player.mo.scale)
				S_StartSound(player.mo, sfx_s3k43)
				player.deathstate = 2
			end
			if player.deathstate != 1
				if player.deathstate == 2
					A_BossScream(player.mo, 1, MT_SMOKE)
				end
				local fire = P_SpawnMobj(player.mo.x+(P_RandomRange(-10,10)*player.mo.scale),player.mo.y+(P_RandomRange(-10,10)*player.mo.scale) ,player.mo.z+(P_RandomRange(-15,25)*player.mo.scale), MT_SPINDUST)
				fire.state = S_SPINDUST_FIRE1
			end
			if P_IsObjectOnGround(player.mo) and not P_CheckDeathPitCollide(player.mo) and player.deathstate == 2 or player.deathstate == 3
				if P_MobjFlip(player.mo)
				player.mo.z = player.mo.floorz
				player.mo.momz = 0
				else
				player.mo.z = player.mo.ceilingz
				player.mo.momz = 0
				end
				P_InstaThrust(player.mo, player.drawangle, 0*player.mo.scale)
				player.mo.state = S_PLAY_FALLEN
				if player.deathstate == 2
				S_StartSound(player.mo, sfx_s3k4c)
				player.deathstate = 3
				end
			end
		end
		if player.deathType == "BOOM" 
			if player.deathstate == 1 
				P_SetObjectMomZ(player.mo, 12*FRACUNIT, false)
				player.mo.color = SKINCOLOR_CARBON
				player.mo.state = S_PLAY_PAIN
				player.mo.colorized = true
				S_StartSound(player.mo, sfx_drexpl)
				P_StartQuake(24*FRACUNIT, 10)
				local kaboom = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_PELOBOOM)
				kaboom.spritexscale = FRACUNIT/2
				kaboom.spriteyscale = FRACUNIT/2
				player.deathstate = 2
			elseif not P_IsObjectOnGround(player.mo) and player.deathstate == 2
				player.mo.rollangle = $ + ANGLE_22h
				player.mo.momz = $ + (-1*P_GetMobjGravity(player.mo)/2)
				P_InstaThrust(player.mo, player.drawangle + ANGLE_180, 32*player.mo.scale)
				A_BossScream(player.mo, 1, MT_SMOKE)
				local fire = P_SpawnMobj(player.mo.x+(P_RandomRange(-4,4)*player.mo.scale),player.mo.y+(P_RandomRange(-4,4)*player.mo.scale) ,player.mo.z+(P_RandomRange(-15,45)*player.mo.scale), MT_SPINDUST)
				fire.state = S_SPINDUST_FIRE1
			else
				if P_MobjFlip(player.mo)
					player.mo.z = player.mo.floorz
					player.mo.momz = 0
				else
					player.mo.z = player.mo.ceilingz
					player.mo.momz = 0
				end
				player.mo.state = S_PLAY_FALLEN
				P_InstaThrust(player.mo, player.drawangle, 0*player.mo.scale)
				player.mo.rollangle = 0
				local fire = P_SpawnMobj(player.mo.x+(P_RandomRange(-10,10)*player.mo.scale),player.mo.y+(P_RandomRange(-10,10)*player.mo.scale) ,player.mo.z+(P_RandomRange(-15,25)*player.mo.scale), MT_SPINDUST)
				fire.state = S_SPINDUST_FIRE1
				if player.deathstate == 2
				S_StartSound(player.mo, sfx_s3k4c)
				player.deathstate = 3
				end
			end
		end
		if player.deathType == "OVERHEAT"
			if player.deathstate == 1
				local kaboom = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_PELOBOOM)
				kaboom.spritexscale = FRACUNIT/2
				kaboom.spriteyscale = FRACUNIT/2
				player.mo.flags2 = $|MF2_DONTDRAW
				S_StartSound(player.mo, sfx_drexpl)
				P_StartQuake(24*FRACUNIT, 10)
				player.deathstate = 2
			end
			player.mo.momz = 0
			P_InstaThrust(player.mo, player.drawangle, 0*player.mo.scale)
		end
		if player.deathType == "DROWN"
			if P_IsObjectOnGround(player.mo) and not P_CheckDeathPitCollide(player.mo) and player.deathstate == 1 or player.deathstate == 2
				if P_MobjFlip(player.mo)
				player.mo.z = player.mo.floorz
				player.mo.momz = 0
				else
				player.mo.z = player.mo.ceilingz
				player.mo.momz = 0
				end
				player.mo.state = S_PLAY_FALLEN
				P_InstaThrust(player.mo, player.drawangle, 0*player.mo.scale)
				if player.deathstate == 1
				S_StartSound(player.mo, sfx_s3k4c)
				player.deathstate = 2
				end
			end
		end
		if player.deathType == "OBJECT" or player.deathType == "SELF"
			if player.deathstate == 1 
				player.mo.state = S_PLAY_PAIN
				player.mo.momz = $ + P_MobjFlip(player.mo)
				P_SetObjectMomZ(player.mo, 6*FRACUNIT)
				P_InstaThrust(player.mo, player.drawangle + ANGLE_180, 6*player.mo.scale)
				player.deathstate = 2
			end
			if P_IsObjectOnGround(player.mo) and not P_CheckDeathPitCollide(player.mo) and player.deathstate == 2 or player.deathstate == 3
				if P_MobjFlip(player.mo)
				player.mo.z = player.mo.floorz
				player.mo.momz = 0
				else
				player.mo.z = player.mo.ceilingz
				player.mo.momz = 0
				end
				P_InstaThrust(player.mo, player.drawangle, 0*player.mo.scale)
				player.mo.state = S_PLAY_FALLEN
				if player.deathstate == 2
				S_StartSound(player.mo, sfx_s3k4c)
				player.deathstate = 3
				end
			end
		end
	end
end

local function BThinkFrame()
	for player in players.iterate
		if player.playerstate == PST_DEAD and not customdeaths[player.mo.skin] 
			if player.deathstate == 0
				player.deathstate = 1
			end
			DoPlayerDeath(player)
		end
	end
end



addHook("MobjDeath", PlayerDeath, MT_PLAYER)

addHook("ThinkFrame", BThinkFrame)





